<!doctype HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html>
<!-- ADMINISTRATION MODULE FOR MyPhotoAlbum - Album creation -->
<?php
$adminprefix = "../";
require $adminprefix.'inc_config.php';
?>
<head>
<title></title>
<link rel="stylesheet" type="text/css" media="screen" href="<?=$adminprefix?>default.css">
</head>
<body>

<table width="100%" cellpadding=0 cellspacing=0><tr>
<td align="left" valign="top" class="header"><?=$LANG_CREATE_NEW_PHOTO_ALBUM?></td>
<td align="right" valign="top" class="header"><sup><?=$LANG_VERSION?>&nbsp;<?=$VERNUM?></sup></td>
</tr></table>

<?php
if (phpversion() < '4.1') {
	$enviar = $HTTP_GET_VARS["enviar"];
	$name = $HTTP_GET_VARS["name"];
	$dirnam = $HTTP_GET_VARS["dirnam"];
	$about = $HTTP_GET_VARS["about"];
	}
else {
	$enviar = $_GET["enviar"];
	$name = $_GET["name"];
	$dirnam = $_GET["dirnam"];
	$about = $_GET["about"];
}

if ($enviar == $LANG_NEW_ALBUM) { /* If we coming from the "submit" button in this same page, let's create */
	$crname = strtolower(str_replace(' ','_',stripslashes($dirnam)));
	
	/* We create the directory if not exists, as well as the two sub-directories if necessary */
	if (!is_dir($adminprefix . $ALBPREFIX . $crname)) {
		if (!mkdir ($adminprefix . $ALBPREFIX . $crname, 0775)) {
				print $LANG_ALBUM_CREATION_ERROR;
				exit;
		}
		if (substr($PICPREFIX, -1, 1) == "/") {
			mkdir ($adminprefix . $ALBPREFIX .$crname . "/" . $PICPREFIX, 0755);
		} 
		if (substr($THUMBPREFIX, -1, 1) == "/") {
			mkdir ($adminprefix . $ALBPREFIX .$crname . "/" . $THUMBPREFIX, 0755);
		}
	}
		
	/* Now we create the database file, but only it doesn't exist yet */
	list ($langlist, $cplist) = createLanglist ($adminprefix);
	
	foreach ($langlist as $key => $val) { /* This will create the database file for all languages */
		if (file_exists($adminprefix . $ALBPREFIX . $crname . "/" . "pictures_".$key.".db")) {
			print $LANG_ALBUM_ALREADY_EXISTS;
			print "<br><br><a href=\"index.php?idm=$idm\">$LANG_BACK_TO_INDEX</a><br>";
			print "\n</body>\n</html>";
			exit;
			}
		else {
			$db_output = '"---","---"'."\n"; /* Default value, in case the file has some error, or the string is not present */
			if (!$fp = fopen($adminprefix . $ALBPREFIX . $crname . "/" . "pictures_".$key.".db","w")) {
				print $LANG_ALBUM_CREATION_ERROR;
				print "\n</body>\n</html>";
				exit;
			}
			if ($key == $idm) { /* If the language being created right now is the one we are using in the interface, then we use the title and description entered by the user */
				$db_output = '"' . stripslashes($name).'","' . stripslashes($about) . "\"\n";
				}
			else { /* For all other languages, we read directly the language files as data */
				if ($lgdata = @fopen($adminprefix . "lang_" . $key . ".inc", "r")) { /* Open the language file for reading */
					while ($lglin = fgetcsv($lgdata,1000, "=") ) { /* Let's read the file line by line */
						if (rtrim($lglin[0]) == '$LANG_NEWLY_CREATED_ALBUM') {
							$db_output = '"' . rtrim($lglin[1], ";") . '","' . rtrim($lglin[1], ";") . "\"\n";
							break; /* We found the required string, so nothing else to do here */
						}
					}
					fclose($lgdata);
				}
			}
			fputs($fp, $db_output);
			fclose($fp);
			chmod ($adminprefix . $ALBPREFIX . $crname . "/" . "pictures_".$key.".db", 0664);
		}
	} /* End of the "while"; see the comment above */

	chmod ($adminprefix . $ALBPREFIX . $crname, 0755);
	print $LANG_ALBUM_CREATED . ":<br><br>";
	?>
	<table width="100%" border="0">
		<tr>
			<td width="10%">&nbsp;</td>
			<td width="90%"><b><?=$name?></b></td>
		</tr>
		<tr>
			<td width="10%">&nbsp;</td>
			<td width="90%"><?=$about?></td>
		</tr>
	</table>
	<br>
	<a href="index.php?idm=<?=$idm?>"><?=$LANG_BACK_TO_INDEX?></a><br>
	<?
	}
else { /* If not, let's display the creation form */
?>
	<a href="index.php?idm=<?=$idm?>"><?=$LANG_BACK_TO_INDEX?></a><br>
	<form action="<?=$PHP_SELF?>" method="get">
	<input type="hidden" name="idm" value="<?=$idm?>">
	<table width="100%">
		<tr>
			<td width="40%" align="right"><?=$LANG_ALBUM_DIRNAM?>:</td>
			<td width="60%" valign="center"><input type="text" name="dirnam" size="30" maxlength="30"></td>
		</tr>
		<tr>
			<td width="40%" align="right"><br><?=$LANG_ALBUM_NAME?>:</td>
			<td width="60%" valign="center"><br><input type="text" name="name" size="30" maxlength="30"></td>
		</tr>
		<tr>
			<td width="40%" align="right" valign="top"><br><?=$LANG_ALBUM_COMMENTS ?>:</td>
			<td width="60%"><br><textarea name="about" cols="50" rows="5"></textarea></td>
		</tr>
		<tr>
			<td></td>
			<td align="left" valign="top"><input type="submit" name="enviar" value="<?=$LANG_NEW_ALBUM?>"></td>
		</tr>
	</table>
	</form>
	<?
} ?>
</body>
</html>
