<!doctype HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html>
<!-- ADMINISTRATION MODULE FOR MyPhotoAlbum - Album management -->
<?php
$adminprefix = "../";
require $adminprefix.'inc_config.php';
/* To abbreviate things, we copy the POST parameters into a local array, thus eliminating version dependency from now on */
if (phpversion() < '4.1') {
	$fromourselves=$HTTP_POST_VARS["fromourselves"];
	$enviar=$HTTP_POST_VARS["enviar"];
	$albumdir=$HTTP_POST_VARS["albumdir"];
	$albumname=$HTTP_POST_VARS["albumname"];
	$albumdesc=$HTTP_POST_VARS["albumdesc"];
	$name=$HTTP_POST_VARS["name"];
	$image=$HTTP_POST_VARS["image"];
	$description=$HTTP_POST_VARS["description"];
	$movement=$HTTP_POST_VARS["movement"];
	$append=$HTTP_POST_VARS["append"];
	$newtitle=$HTTP_POST_VARS["newtitle"];
	$newdescription=$HTTP_POST_VARS["newdescription"];
	$newimagefile=$HTTP_POST_VARS["newimagefile"];
	$filetype=$HTTP_POST_VARS["filetype"];
	$newimagefilename=$HTTP_POST_FILES["newimagefile"]["name"];
	$newimagefilenametmp=$HTTP_POST_FILES["newimagefile"]["tmp_name"];
	}
else {
	$fromourselves=$_POST["fromourselves"];
	$enviar=$_POST["enviar"];
	$albumdir=$_POST["albumdir"];
	$albumname=$_POST["albumname"];
	$albumdesc=$_POST["albumdesc"];
	$name=$_POST["name"];
	$image=$_POST["image"];
	$description=$_POST["description"];
	$movement=$_POST["movement"];
	$append=$_POST["append"];
	$newtitle=$_POST["newtitle"];
	$newdescription=$_POST["newdescription"];
	$newimagefile=$_POST["newimagefile"];
	$filetype=$_POST["filetype"];
	$newimagefilename=$_FILES["newimagefile"]["name"];
	$newimagefilenametmp=$_FILES["newimagefile"]["tmp_name"];
}
if ($albumdir == '') {$albumdir = $alb;} /* Needed to load the CSS before adjusting the parameters */
?>
<head>
<meta http-equiv="content-type" content="text/html; charset=<?=$LANG_CHARSET?>">
<link rel="stylesheet" type="text/css" media="screen" 
href="<?=file_exists($adminprefix.$ALBPREFIX.$albumdir.'/default.css')?$adminprefix.$ALBPREFIX.$albumdir.'/default.css':$adminprefix.'default.css'?>">

<script language="javascript" type="text/javascript">
function viewer2(picture, lang, album, siz) {
	window.open(picture,'Viewer',siz);
}
</script>
<title><?=$LANG_ALBUM_MANAGEMENT?></title>
</head>
<body>
<?php
/* ================================================================== */
/* REWRITING OF THE DATA FILE  */
	$warninglist = ""; /* Here we will accumulate all the warning messages generated during the process, to print them together in a suitable place */
	if (($fromourselves == 'Y') || (sizeof($movement) == 1)) {
		/* Let's swap the required pictures in the list, or delete them (if any) */
		if (sizeof($movement) > 0) { /* To avoid the warning if no change has been requested */
			foreach($movement as $key => $value) { /* Ok, should be only one, but this way I don't have to look up which one is it */
				if (($value == $LANG_MOVE_TO_BEFORE) && ($key > 0)) { /* Case 1: move a picture one space back */
					$temp = $name[$key] ; $name[$key] = $name[$key-1] ; $name[$key-1] = $temp;
					$temp = $image[$key] ; $image[$key] = $image[$key-1] ; $image[$key-1] = $temp;
					$temp = $description[$key] ; $description[$key] = $description[$key-1] ; $description[$key-1] = $temp;
				}
				if (($value == $LANG_MOVE_TO_AFTER) && ($key < sizeof($image)-1)) { /* Case 1: move a picture one space back */
					$temp = $name[$key] ; $name[$key] = $name[$key+1] ; $name[$key+1] = $temp;
					$temp = $image[$key] ; $image[$key] = $image[$key+1] ; $image[$key+1] = $temp;
					$temp = $description[$key] ; $description[$key] = $description[$key+1] ; $description[$key+1] = $temp;
				}
				if ($value == $LANG_DELETE) {
					$temp = $image[$key];
					
					array_splice($name, $key, 1);
					array_splice($image, $key, 1);
					array_splice($description, $key, 1);
					/* Delete the image and thumbnail files, if the configuration is set to do it */
					if ($DELETE_IMAGE_FILES) {
						if (!unlink($adminprefix.$ALBPREFIX.$albumdir. '/' . $PICPREFIX . $temp)) {
							$warninglist .= $LANG_WARNING_NOT_DELETED_IMAGE . ' "' . $temp . '"<br>';
						}
						if (!unlink($adminprefix.$ALBPREFIX.$albumdir. '/' . $THUMBPREFIX . $temp)) {
							$warninglist .= $LANG_WARNING_NOT_DELETED_THUMB .' "'. $temp . '"<br>';
						}
					}
				}
			}
		}

		/* Handling of the uploaded file, if any */
		if ($newimagefilenametmp > '') {
			$imagepath = $adminprefix.$ALBPREFIX.$albumdir. '/' . $PICPREFIX; /* This is gonna be used both for images and for zipfiles, so we put it here */
			$thumbpath = $adminprefix.$ALBPREFIX.$albumdir. '/' . $THUMBPREFIX; /* Same for this one */
			if ($filetype == 'img') { /* We got an image file; movement of the uploaded image to its place */
				$imagepathname = $imagepath . $newimagefilename;
				$thumbpathname = $thumbpath . $newimagefilename;
					
				if (move_uploaded_file($newimagefilenametmp, $imagepathname)) {
					list($width, $height) = getimagesize($imagepathname); /* First we get the image size, which will be used for resizing and thumb creation */
					$imageresource = imagecreatefromjpeg($imagepathname); /* And we store it in a resource */
						
					/* Creation of the thumbnail */
					$new_width = ($width>$height?$THUMBWIDTH:$THUMBHEIGHT); /* Adjusting the size of the thumb for portrait or landscape */
					$new_height = ($width>$height?$THUMBHEIGHT:$THUMBWIDTH); /* Adjusting the size of the thumb for portrait or landscape */
					CreateResized($imageresource, $new_width, $new_height, $thumbpathname); /* Thumb creation */
						
					/* Now we resize the original picture if required by config */
					if (($width > $MAXIMGWIDTH)||($height > $MAXIMGHEIGHT)){ /* If image size is too big... */
						$new_width = ($width>$height?$MAXIMGWIDTH:$MAXIMGHEIGHT); /* We adjust the size of the thumb for portrait or landscape */
						$new_height = ($width>$height?$MAXIMGHEIGHT:$MAXIMGWIDTH); /* We adjust the size of the thumb for portrait or landscape */
						CreateResized($imageresource, $new_width, $new_height, $imagepathname);
					}
					imagedestroy($imageresource);
				}
				else { /* If there was some problem, we save the warning message to print it later, in a proper place of the page */
					$warninglist .= $LANG_UPLOAD_WRITERROR .' "'. $newimagefilename . '"<br>';
				}
			} /* End of imagefile treatment */
			
			if ($filetype == 'zip') { /* We got a zipfile; let's open it and put the images into the directory */
				$zip = zip_open($newimagefilenametmp);
				if ($zip) {
					while ($zip_entry=zip_read($zip)) {
						if ( (zip_entry_open($zip, $zip_entry, 'rb'))&&(zip_entry_filesize($zip_entry) < $MAX_ZIPENTRY_SIZE) ) {
							$imagepathname = $imagepath . zip_entry_name($zip_entry); /* This will be the pathname of the JPEG file when we write it */
							$thumbpathname = $thumbpath . zip_entry_name($zip_entry); /* This will be the pathname of the JPEG thumbnail file when we write it */
							$newnames[] = zip_entry_name($zip_entry); /* This array will be used to create the new lines in the datafile */
								
							/* Now we read the file (hopefully an image) into the variable $buf */
							$buf = zip_entry_read($zip_entry, zip_entry_filesize($zip_entry));
								
							if ($imageresource = imagecreatefromstring($buf)) { /* If we successfully create an image from the extracted bytes... */
								/* ...we create the thumbnail for the image we just extracted */
								$width = imagesx($imageresource); /* First we get the image size */
								$height = imagesy($imageresource);
								$new_width = ($width>$height?$THUMBWIDTH:$THUMBHEIGHT); /* Adjusting the size of the thumb for portrait or landscape */
								$new_height = ($width>$height?$THUMBHEIGHT:$THUMBWIDTH); /* Adjusting the size of the thumb for portrait or landscape */
								CreateResized($imageresource, $new_width, $new_height, $thumbpathname); /* Thumb creation */
									
								if (($width > $MAXIMGWIDTH)||($height > $MAXIMGHEIGHT)){ /* If image size is too big... */
									$new_width = ($width>$height?$MAXIMGWIDTH:$MAXIMGHEIGHT); /* We adjust the size of the thumb for portrait or landscape */
									$new_height = ($width>$height?$MAXIMGHEIGHT:$MAXIMGWIDTH); /* We adjust the size of the thumb for portrait or landscape */
									CreateResized($imageresource, $new_width, $new_height, $imagepathname);
								}
								else { /* Else (the image size is not too big), we just write it as it is */
									imagejpeg($imageresource, $imagepathname);
								}
								imagedestroy($imageresource); /* Done! Let's free up the memory */
							}
							else {
								$warninglist .= $LANG_ZIPFILE_ENTRY_ERROR .' "'. zip_entry_name($zip_entry) . '"<br>';
							}
						}
						else {
							$warninglist .= $LANG_ZIPFILE_ENTRY_ERROR .' "'. zip_entry_name($zip_entry) . '"<br>';
						}
						zip_entry_close($zip_entry); /* Even if we didn't manage to open it? Hum... */
					}
					zip_close($zip);
				}
				else { /* If there was some problem, we save the warning message to print it later, in a proper place of the page */
					$warninglist .= $LANG_ZIPFILE_OPEN_ERROR .' "'. $newimagefilenametmp . '"<br>';
				}
			} /* End of zipfile treatment; don't bother deleting, it's a temporary uploaded file and PHP will take care of it */
		}
		
		/* Now we re-write the data file */
		$picfilename = $adminprefix.$ALBPREFIX.$albumdir.'/pictures_'.$idm.'.db';
		if ($fp = fopen ($picfilename,'w') ) {
			fwrite($fp, "\"".$albumname."\",\"".$albumdesc."\"\n");
			if (count($image) > 0) {
				foreach( $image as $key => $value ) {
					fwrite($fp, '"' . $name[$key] . '",' . $value . ',"' . $description[$key] . "\"\n");
				}
			}
				
			/*...of course, adding the newly created line[s] at the end, if any */
			/* NOTICE: You might find the usage and combination of single and double quotes inconsistent, ugly, or even confusing; well, the mixup of countless backslashes and single-double-triple-quotes ("') was making me dizzy, so I chose the solution I liked best. If you don't like it... well, that's why you have the source code! */
			if ($filetype == 'img') { /* Filetype is an image; therefore we have the three fields */
				if ($newtitle . $newimagefilename . $newdescription > "") {
					fwrite($fp, '"' . $newtitle . '",' . $newimagefilename . ',"' . $newdescription . "\"\n");
				}
			}
			if ($filetype == 'zip') { /* Filetype is a zip, so we have to create lines with empty descriptions, one for each entry in the zip */
				foreach($newnames as $newname) {
					fwrite($fp, '"'. $newtitle .'",' . $newname . ',"' . $newdescription . '"' . "\n");
					/* I like to put the same title to different pics, so if title and/or desc are filled in, all the pics in the zip will have the same */
				}
			}
			fclose($fp);
			
			/* From here, we jump to display the page again, except in case of I/O error (addressed just below here) */
			/* ...but before, due to the differences between GET and PUT methods, we pass the parameter from one to the other: */
			$alb = $albumdir;
		}
		else {
			$warninglist .= $LANG_FILE_WRITE_ERROR . ' "'.$picfilename .'"<br>';
		}
		
		/* Now we are going to synchronize the file with all the other defined languages; we are going to use the three tables we got:	$name, $image and $description */
		list ($langlist, $langset) = createLanglist($adminprefix);
		foreach ($langlist as $synidm => $value) { /* For every language we found... */
			if ($synidm == $idm) { continue; } /* ...except the one we are already using, of course...*/
			$synfilename = $adminprefix.$ALBPREFIX.$alb.'/pictures_'.$synidm.'.db';
			if (!$fp = @fopen ($synfilename,'r') ) {
				$warninglist .= $LANG_WARNING_NOT_SYNCHRONIZED . $synidm . $LANG_WARNING_NOT_SYNCHRONIZED_READ . "<br>";
				continue; /* If we couldn't open this language file, we just print a warning and skip to the next */
			}
			$synfirstline = fgets($fp,10000); /* Let's get the first line, which holds the album name and description. We are not going to alter this one. */
			//while (list ($synname[$synidx], $synimage[$synidx], $syndescription[$synidx]) = fgetcsv($fp, 10000)) { /* We read the rest of the file using a loop */
			while (list ($synfield0, $synimage, $synfield1) = fgetcsv($fp, 10000)) { /* We read the rest of the file using a loop */
				if ($synimage > '') {
					$synname[$synimage] = $synfield0;
					$syndescription[$synimage] = $synfield1;
				}
			}
			fclose ($fp); /* We got all the data needed, so we close the db file */
			/* Now we have two tables ($synname and $syndescription) indexed by the filename of the image; let's use them to rewrite the data file for the other languages in the same order we find in the "master" file we have. */
			if (!$fp = @fopen ($synfilename,'w') ) {
				$warninglist .= $LANG_WARNING_NOT_SYNCHRONIZED . $synidm . $LANG_WARNING_NOT_SYNCHRONIZED_WRITE . "<br>";
				continue; /* If we couldn't open this language file, we just print a warning and skip to the next */
			}
			fwrite($fp, $synfirstline); /* Let's write the first line, the album header, exactly as it was read */
			if (count($image) > 0) { /* To avoid the ugly warning if the album is empty */
				foreach ($image as $synvalue) { /* Let's browse the "original" list, freshly modified by the user, in the same order it was passed by the Submit button */
					fwrite($fp, '"'.$synname[$synvalue] . '",'.$synvalue.',"'.$syndescription[$synvalue]."\"\n");
				}
			}
			if ($filetype == 'img') { /* For images, the name, of course */
				if ($newtitle . $newimagefilename . $newdescription > "") { /* Let's append the newly added image, if any */
					fwrite($fp, '"",' . $newimagefilename . ",\"\"\n"); /* Of course, the new title and description will be blank; you can add them later by editing the album in this language */
				}
			}
			if ($filetype == 'zip') { /* For zipfiles, the list of names from the array we saved */
				foreach($newnames as $newname) {
					fwrite($fp, '"",' . $newname . ',""' . "\n");
				}
			}
			fclose($fp);
		}
	} /* We just finished the movement operations (if any; if not we just jumped directly here). Now we are continuing to the form display part. */

/* ================================================================== */
/* DISPLAY OF THE FORM, BE IT INITIAL OR RESULT OF A PREVIOUS PROCESS */
	/* Open pictures description file; the name depends on the album and language */
	if ($alb == '') {$alb=$_GET['alb']; }
	$picfilename = $adminprefix.$ALBPREFIX.$alb.'/pictures_'.$idm.'.db';
	if (!$fp = @fopen ($picfilename,'r') ) {
		print "<title>".$LANG_NOT_CONFIGURED."</title>";
		print "</head><body>".$LANG_NOT_CONFIGURED."</body></html>";
		exit;
	}
	$albinfo = fgetcsv($fp,10000); /* Let's get the first line, which holds the album name(0) and description(1) */
	?>
	
	<!-- This is the top header, with the title of the album, version, etc -->
	<table width="100%" cellpadding=0 cellspacing=0>
		<tr>
			<td align="left" valign="top" class="header"><?=$albinfo[0]." - ".$LANG_ALBUM_MANAGEMENT?></td>
			<td align="right" valign="top" class="header"><sup><?=$LANG_VERSION?>&nbsp;<?=$VERNUM?></sup></td>
		</tr>
	</table>
	
	<!-- This is the "back to index" link -->
	<a href="index.php?idm=<?=$idm?>"><?=$LANG_BACK_TO_INDEX?></a><br><br>
	
	<!-- Here we print the warnings from the previous process, if any -->
	<p class="errmsg">
	<?=$warninglist?>
	</p>
	<!-- The rest of the page will be a big form to allow the changes in all descriptions and titles -->	
	<form action="<?=$PHP_SELF?>" method="post" enctype="multipart/form-data">
		<input type="hidden" name="fromourselves" value="Y"> <!-- This will help to know if we come from this form or not, when we reload the page to update the files. Yes, I know there is something called "HTTP_REFERER", but... can you trust it? I can't. -->
		<input type="hidden" name="idm" value="<?=$idm?>">
		<input type="hidden" name="albumdir" value="<?=$alb?>">
		<input type="hidden" name="MAX_FILE_SIZE" value="<?=$MAX_UPL_SIZE?>">
		
		<!-- Part for the album generic data: title and description -->
		<table width="100%" cellpadding=0 cellspacing=10>
			<tr>
				<td width="100%" align="justify" valign="top" class="info">
					<b><?=$LANG_ALBUM_NAME?>:&nbsp;</b><input type="text" size=30 maxlength=30 name="albumname" value="<?=$albinfo[0]?>">
				</td>
			</tr>
			<tr>
				<td width="100%" align="justify" valign="top" class="info">
					<b><?=$LANG_ABOUT?></b><br><br><textarea rows="5" cols="80" name="albumdesc"><?=stripslashes($albinfo[1])?></textarea>
				</td>
			</tr>
		</table>
		
		<!-- Button to submit the changes -->
		<p align="center">
			<input type="submit" name="enviar" value="<?=$LANG_SEND_CHANGES?>">
		</p>
			
		<!-- Main part of the form, showing the images to modify the descriptions and positions -->
		<table width="100%" cellpadding=0 cellspacing=5>
			<tr>
				<td width="25%">&nbsp;</td><td width="25%">&nbsp;</td><td width="25%">&nbsp;</td><td width="25%">&nbsp;</td>
			</tr>
			<tr>
			<?php
			/* Now we pre-read the entire descriptions file into the "picsinfo" array */
			/* Each row (indexed by [$row]) holds: [0]->title; [1]->image name; [2]->description */
			$maxidx = 0;
			while ($picsinfo[$maxidx] = fgetcsv($fp, 10000) ) {
				$maxidx++;
			}
			fclose ($fp);/* We got all the data needed, so we close the db file */
			$column = 0; /* This is the column counter, to get 4 pictures per row */
			for ($row = 0; $row < $maxidx; $row++) {/* Let's read the file line by line; */
				$column++;
				?>
				<!-- Table element: title, image, description and buttons -->
				<td width="25%" align="justify" valign="top" class="desc">
					<!--Title-->
					<div class="title">
					<input type="text" name="name[<?=$row?>]" value="<?=stripslashes($picsinfo[$row][0])?>">
					</div>
						
					<!-- Image, with a pop-up option if you cannot see the pic clearly enough to describe it :-) -->
					<?php /* Get the size of the image for the pop-up window */
					$size = getimagesize($adminprefix.$ALBPREFIX.$alb.'/'.$PICPREFIX.$picsinfo[$row][1]);
					if (strstr($_SERVER['HTTP_USER_AGENT'], "Opera")) {	$size[0] += 8; $size[1] += 24; } /* Bug in Opera: it opens the windows a bit smaller than required */
					$tamany = 'width='.$size[0].',height='.$size[1];
					?>
					<a onClick="viewer2('<?=$adminprefix.$ALBPREFIX.$alb.'/'.$PICPREFIX.$picsinfo[$row][1]?>', '<?=$idm?>', '<?=$alb?>', '<?=$tamany?>')">
						<img class="thumb" src="<?=$adminprefix.$ALBPREFIX.$alb.'/'.$THUMBPREFIX.$picsinfo[$row][1]?>" alt="<?=$LANG_PICTURE?>" align="left" border=0>
					</a>
						
					<!-- Description -->
					<input type="hidden" name="image[<?=$row?>]" value="<?=$picsinfo[$row][1]?>">
					<textarea rows="3" cols="20" name="description[<?=$row?>]"><?=stripslashes($picsinfo[$row][2])?></textarea>
					<br>
					<!-- Movement buttons -->
					<?php if ($row > 0) {?><input type="submit" name="movement[<?=$row?>]" value="<?=$LANG_MOVE_TO_BEFORE?>"><?}?>
					<?php if ($row < $maxidx-1) {?><input type="submit" name="movement[<?=$row?>]" value="<?=$LANG_MOVE_TO_AFTER?>"><?}?>
					<input type="submit" name="movement[<?=$row?>]" value="<?=$LANG_DELETE?>">
				</td>
				<?php
				if ($column > 3) { /* If we just printed the fourth pic of the row... */
					print "</tr>\n"; /* ...close the row... */
					print "<tr>\n";
					$column = 0;
				}
			}
			if ($column <= 3) { print "<td></td></tr>\n"; } /* If the last row didn't have four pics, close it now */
			?>
		</table>

		<!-- Part to upload new images -->
		<center>
		<table border="0" width="80%">
			<tr>
				<td class="title" align="center" colspan=2><b><?=$LANG_ADD_PICTURE?></b></td>
			</tr>
			<tr>
				<td align="right"><?=$LANG_UPLOAD_TYPE?></td>
				<td>
					<input type="radio" name="filetype" value="img" checked><?=$LANG_UPLOAD_TYPE_IMG?>&nbsp;&nbsp;
					<input type="radio" name="filetype" value="zip"><?=$LANG_UPLOAD_TYPE_ZIP?>
				</td>	
			</tr>
			<tr>
				<td align="right"><?=$LANG_UPLOAD_PICFILE?>:</td>
				<td align="left"><input type="file" name="newimagefile"></td>
			</tr>
			<tr>
				<td align="right"><?=$LANG_UPLOAD_TITLE?>:&nbsp;</td><td align="left"><input type="text" name="newtitle" value=""></td>
			</tr>
			<tr>
				<td align="right"><?=$LANG_UPLOAD_DESCRIPTION?>:&nbsp;</td><td align="left"><textarea rows="3" cols="20" name="newdescription"></textarea></td>
			</tr>
			<tr>
				<td colspan=2 align="center"><i><?=$LANG_UPLOAD_ALL_SAME?></i></td>
			</tr>		
		</table>
		</center>

		<!-- Button to submit the changes (yes, another one; I found it's convenient for large albums) -->
		<p align="center">
			<input type="submit" name="enviar" value="<?=$LANG_SEND_CHANGES?>">
		</p>
	</form>
</body>
<?php
/* A simple auxiliary function which writes a resize JPEG file from an image resource */
/* I think about it more in terms of a macro than of a function, but it IS a function, of course */
function CreateResized($originalresource, $rswidth, $rsheight, $rsfilnam) {
	$rszresource = imagecreatetruecolor($rswidth, $rsheight);
	imagecopyresampled($rszresource, $originalresource, 0, 0, 0, 0, $rswidth, $rsheight, imagesx($originalresource), imagesy($originalresource));
	imagejpeg($rszresource, $rsfilnam);
	imagedestroy($rszresource);
}
?>
</html>
<!-- END OF FILE -->
