<!doctype HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html>
<?php require 'inc_config.php'; ?>
<head>
<meta http-equiv="content-type" content="text/html; charset=<?=$LANG_CHARSET?>">
<link rel="stylesheet" type="text/css" media="screen" href="<?=file_exists($ALBPREFIX.$alb.'/default.css')?$ALBPREFIX.$alb.'/default.css':'default.css'?>">

<script language="javascript" type="text/javascript">
function viewer(picture, lang, album)
{
	window.open('showpic.php?picture='+picture+'&idm='+lang+'&alb='+album,'Viewer','width=320,height=240');
}
</script>
<?php

/* Open pictures description file; the name depends on the album and language */

$picfilename = $ALBPREFIX.$alb.'/pictures_'.$idm.'.db';
if (!$fp = @fopen ($picfilename,'r') )
{
	print "<title>".$LANG_NOT_CONFIGURED."</title>";
	print "</head><body>".$LANG_NOT_CONFIGURED."</body></html>";
	exit;
}

$data = fgetcsv($fp,100000);
?>
<title><?=$data[0]?></title>
</head>

<body>
<table width="100%" cellpadding=0 cellspacing=0>
<tr><td align="left" valign="top" class="header"><?=$data[0]?></td>
<td align="right" valign="top" class="header"><sup><?=$LANG_VERSION?>&nbsp;<?=$VERNUM?></sup></td>
</tr></table>

<a href="index.php?idm=<?=$idm?>"><?=$LANG_BACK_TO_INDEX?></a><br>
<br>

<table width="100%" cellpadding=0 cellspacing=10>
<tr>
	<td width="100%" align="justify" valign="top" class="info"><b><?=$LANG_ABOUT?></b><br><br><?=stripslashes($data[1])?></td>
</tr>
</table>

<table width="100%" cellpadding=0 cellspacing=5>
<tr>
	<td width="25%">&nbsp;</td><td width="25%">&nbsp;</td><td width="25%">&nbsp;</td><td width="25%">&nbsp;</td>
</tr>
<tr>
<?php
for ($i = 1; $i <= $page * $ROWSPAGE * 4; $i++) { /* First we skip the pictures previous to the page we need */
	$data = fgetcsv($fp,1000);
}
$row = 1; /* This is the row counter, to get the maximum rows signaled in $ROWSPAGE in config file */
$column = 1; /* This is the column counter, to get 4 pictures per row */
while ($data = fgetcsv($fp,1000) ) { /* Let's read the file line by line; $data becomes an array with 3 elements: title, filename and description */
	$column++;
	?>
	<td width="25%" align="justify" valign="top" class="desc">
		<div class="title"><?=stripslashes($data[0])?>&nbsp;</div>
		<a onClick="viewer('<?=$PICPREFIX.$data[1]?>', '<?=$idm?>', '<?=$alb?>')"><img class="thumb" src="<?=$ALBPREFIX.$alb.'/'.$THUMBPREFIX.$data[1]?>" alt="<?=$LANG_PICTURE?>" align="left" border=0></a>
		<?=stripslashes($data[2])?>&nbsp;
		</td>
	<?php
	if ($column > 4) { /* If we just printed the fourth pic of the row... */
		print "</tr>\n"; /* ...close the row... */
		if (++$row > $ROWSPAGE) { /* ...and check if we printed enough rows */
			break; /* No more pics, or the page would be too long */
			}
		else { /* Okay, we can still print more rows, so let's open a new row */
			print "<tr>\n";
			$column = 1;
		}
	}
}

/* close the db file */
if ($column <= 4) { print "<td></td></tr>\n"; } /* If the last row didn't have four pics, close it now */
?>

</table>
<table width="60%" border=0 align="center">
<tr>
<?php
if ($page > 0) { /*If we are not in the first page, then put the "Previous Page" button*/
	$button = (file_exists($ALBPREFIX.$alb.'/ppage.gif')?$ALBPREFIX.$alb.'/ppage.gif':'ppage.gif');
	print "<td align=\"center\">\n<a href='gallery.php?page=" . ($page - 1) . "&amp;idm=" .$idm. "&amp;alb=" .$alb. "'>";
	print "<img class=\"butn\" src=\"".$button."\" width=\"30\" height=\"30\" border=\"0\" alt=\"".$LANG_PREV_PAGE."\"><br>";
	print $LANG_PREV_PAGE;
	print "</a></td>";
} 

if (fgetcsv($fp,1000)) { /*If there are still more pictures left to print, then put the "Next Page" button*/
	$button = (file_exists($ALBPREFIX.$alb.'/npage.gif')?$ALBPREFIX.$alb.'/npage.gif':'npage.gif');
	print "<td align=\"center\">\n<a href='gallery.php?page=" . ($page + 1) . "&amp;idm=" .$idm. "&amp;alb=" .$alb. "'>";
	print $LANG_NEXT_PAGE;
	print "<br><img class=\"butn\" src=\"".$button."\" width=\"30\" height=\"30\" border=\"0\" alt=\"".$LANG_NEXT_PAGE."\">";
	print "</a></td>";
} 
fclose ($fp);
?>
<td></td>
</tr>
</table>
</body>
</html>
