<!doctype HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html>
<!-- ADMINISTRATION MODULE FOR MyPhotoAlbum - Main Menu -->
<?php
$adminprefix = "../";
require $adminprefix.'inc_config.php'; ?>
<head>
<meta http-equiv="content-type" content="text/html;charset=<?=$LANG_CHARSET?>">
<link rel="stylesheet" type="text/css" media="screen" href="<?=$adminprefix?>default.css">
<title></title>
</head>
<body>

<table width="100%" cellpadding=0 cellspacing=0><tr>
<td align="left" valign="top" class="header"><?=$LANG_HEADER." - ".$LANG_ADMIN_HEADER?></td>
<td align="right" valign="top" class="header"><sup><?=$LANG_VERSION?>&nbsp;<?=$VERNUM?></sup></td>
</tr></table>
<a href="../index.php?idm=<?=$idm?>"><?=$LANG_BACK_TO_INDEX?></a><br>
<br>
<!-- ======================================LIST OF LANGUAGES=================================== -->
<?php list($langlist, $langlset) = createLanglist(".."); /* We load the languages and codepages list from the function in the include file */?>

<form name="frm" action=""> <!--This form will allow to select the language-->
	&nbsp;&nbsp;&nbsp;<?=$LANG_CHOOSE_LANGUAGE?>&nbsp;
	<select name="idm" onChange="javascript:document.location.replace(document.URL.substring(0,document.URL.indexOf('?'))+'?idm='+frm.idm.value)">
	<?php /* Let's create the selection list for the available languages, using the hash array we created before */
		while (list ($key, $val) = each ($langlist)) {
            echo "<option value=\"$key\"";
			if ($idm == $key) echo " selected"; /*We show the one we got as parameter by default (so the page appears to "remember" which language)*/
			echo ">$val</option>\n";
		}
    ?>
	</select>
</form>
<br>

<!-- ====================================LIST OF DIRECTORIES=================================== -->
&nbsp;&nbsp;&nbsp;<strong><?=$LANG_ALBUM_DIRECTORIES?></strong>
<?php
/* Get album directories into an array and sort them */
$dh = opendir(".."); 
$cn = 0;
while (($entry = readdir($dh))) { 
	if (substr($entry,0,strlen($ALBPREFIX)) == $ALBPREFIX) {  
	   $d[$cn++] = $entry;
	}
}
closedir($dh);
rsort ($d); /* I use the notation "commonprefix_yyyy_mm_dirname" for the album directories, so I use "R"sort to get the newest first. Sorry guys :-) */

print "<table border=0>\n"; /* this simple table is only to avoid overflowing if the album description ("about") is too long */
print "<tr><td valign=\"top\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>";
print "<td valign=\"top\"><a href=\"create.php?idm=".$idm."\"><i><b>(" . $LANG_CREATE_NEW_PHOTO_ALBUM . ")</b></i></a></td><td></td>";
foreach ($d as $entry) {
	if ($fp = @fopen ($adminprefix.$entry."/pictures_".$idm.".db", 'r')) { /* Hum... why not print the description/comments for the album? */
		$data = fgetcsv($fp,100000); ?>
		<tr>
			<td valign="top">
				&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;-&nbsp;
			</td>
			<td valign="top">
				<a href="manage.php?idm=<?=$idm?>&amp;alb=<?=urlencode(substr($entry, strlen($ALBPREFIX)))?>"><b><?=$data[0]?></b></a>:
			</td>
			<td>
				&nbsp;<?=$data[1]?>
				<?php
				$numpics = 0; /*Put the counter of pictures to zero to avoid adding up different albums */
				while ($data = fgetcsv($fp,1000)) $numpics++; /*Let's count the lines so we know how many pics we have */
				fclose($fp);
				print " (<i>".$numpics." ".$LANG_PICTURES."</i>)";
	}?>
			</td>
		</tr>
<? } ?>
</table>
<br>
</body>
</html>
